﻿function Select-fichier(){

    $initialDirectory = $home + "\Desktop"

    $seachExt = "fichier csv (*.csv)| *.csv"



    [void] [Reflection.Assembly]::LoadWithPartialName( 'System.Windows.Forms' )

    $fileDialogBox = New-Object Windows.Forms.OpenFileDialog

    $fileDialogBox.ShowHelp = $true

    $fileDialogBox.initialDirectory = $initialDirectory

    $fileDialogBox.filter = $seachExt

    $fileDialogBox.ShowDialog( )

    $fileDialogBox.filename

}



# Note : La valeur filename est la deuxième renvoyé par la fonction d'où le $logFileName[1]

$fichiercsv = Select-Fichier

$fichiercsv = $fichiercsv[1]



        # importation du module Exchange
        $s = New-PSSession -ConfigurationName Microsoft.Exchange `
        -ConnectionUri http://exch2013.rumilly.local/PowerShell/ `
        -Authentication Kerberos

        Import-PSSession $s


        # Importation du fichier .CSV
        $utilisateurs = Import-Csv -path $fichiercsv -delimiter ";"

       # Changez le nom du serveur, des emplacements par défaut des banques et des logs!!!

        #définition des variables
        $domaine = $utilisateurs.netbiosdomaine
        $domaineFQDN = $utilisateurs.domaine
        $servexch = "exch2013.rumilly.local"
        $pathedborg = "D:\Bases\"
        $pathlogorg = "D:\Logs\"
        $pathlog = $pathlogorg +"\" +$domaine +"\"
        $banque = $pathedborg +"\"+ $domaine +"\"+ $domaine + ".edb"
        $chemfich = $HOME + "\Desktop"
        $fileusers = $chemfich + "\" + $domaine + ".csv"
        $offlinebook = $domaine +"OAB"
        $virtualoabfront = $servexch + "\oab (Default Web Site)"
        $virtualoabback = $servexch + "\oab (Exchange Back End)"
        $bookpolicy = $domaine + "ABP"
        $addlist = "\" + $domaine
        $gal = $domaine + "GAL"
        $roomlist = $domaine + "Rooms"
        $AddressTemplates = "SMTP:%s%2g@" + $domaineFQDN


# Chamgez le chemin de l'ou!!!

        $ou = "ou=" +$domaine + ",ou=clients,dc=rumilly,dc=local"
        New-ADOrganizationalUnit -Name $domaine -Path "ou=clients,dc=rumilly,dc=local"
     


# Création de l’utilisateur
cls
foreach($utilisateur in $utilisateurs)
    {
        $pass = $utilisateur.password
        $nom = $utilisateur.sn
        $prenom = $utilisateur.givenname
        $displayname = $utilisateur.displayname
        $name = $utilisateur.name
        $login = $utilisateur.samaccountname
        $mail = $utilisateur.mail
        $password = $utilisateur.password

New-ADUser –name $name –givenname $givenname –surname $sn –displayname $displayname –samaccountname $login –emailaddress $mail –enabled 1 -UserPrincipalName $mail –accountpassword (convertto-securestring $password –asplaintext –force) -Path $ou
echo « Utilisateur $displayname créé »
    }



        # Création de l'arborescence
        New-Item -Path $pathedb\$domaine -ItemType directory
        New-Item -Path $pathlog -ItemType directory


        #Création de la banque
        New-MailboxDatabase -name $domaine -server $servexch -EdbFilePath $banque -LogFolderPath $pathlog
        Invoke-Command -ComputerName $servexch -ScriptBlock {Restart-Service MSExchangeIS}
        Mount-Database -Identity $domaine

        New-AcceptedDomain -Name $domaineFQDN -DomainName $domaineFQDN -DomainType Authoritative
        New-EmailAddressPolicy -Name $domaineFQDN -IncludedRecipients MailboxUsers -RecipientContainer $ou -EnabledEmailAddressTemplates $AddressTemplates -Priority 1
        Update-EmailAddressPolicy -Identity $domaineFQDN

        #Activation des bals pour l'ou
        Get-User -OrganizationalUnit $domaine | Enable-Mailbox -Database $domaine
        Get-Group -OrganizationalUnit $domaine | Enable-DistributionGroup $domaine

        New-DynamicDistributionGroup -Name $domaine -Alias $domaine -IncludedRecipients MailboxUsers -OrganizationalUnit $ou -RecipientContainer $ou

        # Stratégies et Listes d'adresses pour $domaine

        # Carnet d'adresses pour $domaine
        New-GlobalAddressList -Name $gal -RecipientContainer $domaine
        Update-GlobalAddressList -Identity $gal
        New-AddressList -name $roomlist -RecipientContainer $domaine -IncludedRecipients resources
        New-AddressList -name $domaine -RecipientContainer $domaine -IncludedRecipients mailboxUsers
        New-OfflineAddressBook -Name $offlinebook -AddressLists $domaine
        Update-AddressList $domaine
        Update-AddressList $roomlist
        Set-OfflineAddressBook -Identity $offlinebook -VirtualDirectories $virtualoab, $virtualoabback
        Update-OfflineAddressBook -id $offlinebook
        New-AddressBookPolicy -name $bookpolicy -AddressLists $addlist -OfflineAddressBook $offlinebook -GlobalAddressList $gal -RoomList $roomlist
        Get-Mailbox -OrganizationalUnit $domaine | Set-Mailbox -AddressBookPolicy $bookpolicy